{-# OPTIONS -optc-DPACKAGE="ginsu" #-}
{-# OPTIONS -optc-DVERSION="0.3.1" #-}
{-# OPTIONS -optc-DHAS_CURSES=1 #-}
{-# OPTIONS -optc-DUSE_NCURSES=1 #-}
{-# OPTIONS -optc-DHAVE_LIBCRYPTO=1 #-}
{-# OPTIONS -optc-DHAVE_PKG_openssl=1 #-}
{-# OPTIONS -#include <openssl/rsa.h> #-}
{-# LINE 1 "RSA.hsc" #-}
module RSA where
{-# LINE 2 "RSA.hsc" #-}


{-# LINE 4 "RSA.hsc" #-}

import Foreign
import CForeign

data RSAStruct 

type RSA = Ptr RSAStruct

foreign import ccall unsafe "RSA_new" rsaNew :: IO RSA
foreign import ccall unsafe "RSA_free" rsaFree :: RSA -> IO ()

-- int RSA_public_encrypt(int flen, unsigned char *from, unsigned char *to, RSA *rsa, int padding);
foreign import ccall unsafe "RSA_public_encrypt" rsaPublicEncrypt :: CInt -> Ptr CUChar -> Ptr CUChar -> RSA -> CInt -> IO CInt

-- int RSA_private_decrypt(int flen, unsigned char *from, unsigned char *to, RSA *rsa, int padding);
foreign import ccall unsafe "RSA_public_decrypt" rsaPublicDecrypt :: CInt -> Ptr CUChar -> Ptr CUChar -> RSA -> CInt -> IO CInt

--int RSA_sign(int type, unsigned char *m, unsigned int m_len, unsigned char *sigret, unsigned int *siglen, RSA *rsa);
foreign import ccall unsafe "RSA_sign" rsaSign :: CInt -> Ptr CUChar -> CUInt -> Ptr CUChar -> Ptr CUInt -> RSA -> IO CInt

--int RSA_size(RSA *rsa);
foreign import ccall unsafe "RSA_size" rsaSize :: RSA -> IO CInt

-- int RSA_verify(int type, unsigned char *m, unsigned int m_len, unsigned char *sigbuf, unsigned int siglen, RSA *rsa);
foreign import ccall unsafe "RSA_verify" rsaVerify :: CInt -> Ptr CUChar -> CUInt -> Ptr CUChar -> CUInt -> RSA -> IO CInt

-- RSA *RSA_generate_key(int num, unsigned long e, void (*callback)(int,int,void *), void *cb_arg);
foreign import ccall "RSA_generate_key" rsaGenerateKey :: CInt -> CULong -> (FunPtr (CInt -> CInt -> Ptr () -> IO ())) -> Ptr () -> IO RSA

-- int RSA_check_key(RSA *rsa);
foreign import ccall unsafe "RSA_check_key" rsaCheckKey :: RSA -> IO CInt

{-

int RSA_blinding_on(RSA *rsa, BN_CTX *ctx);
 void RSA_blinding_off(RSA *rsa);

void RSA_set_default_openssl_method(RSA_METHOD *meth);
 RSA_METHOD *RSA_get_default_openssl_method(void);
 int RSA_set_method(RSA *rsa, ENGINE *engine);
 RSA_METHOD *RSA_get_method(RSA *rsa);
 RSA_METHOD *RSA_PKCS1_SSLeay(void);
 RSA_METHOD *RSA_null_method(void);
 int RSA_flags(RSA *rsa);
 RSA *RSA_new_method(ENGINE *engine);

int RSA_print(BIO *bp, RSA *x, int offset);
 int RSA_print_fp(FILE *fp, RSA *x, int offset);

int RSA_get_ex_new_index(long argl, char *argp, int (*new_func)(),
    int (*dup_func)(), void (*free_func)());
 int RSA_set_ex_data(RSA *r,int idx,char *arg);
 char *RSA_get_ex_data(RSA *r, int idx);

int RSA_private_encrypt(int flen, unsigned char *from,
    unsigned char *to, RSA *rsa,int padding);
 int RSA_public_decrypt(int flen, unsigned char *from,
    unsigned char *to, RSA *rsa,int padding);

int RSA_sign_ASN1_OCTET_STRING(int dummy, unsigned char *m,
    unsigned int m_len, unsigned char *sigret, unsigned int *siglen,
    RSA *rsa);
 int RSA_verify_ASN1_OCTET_STRING(int dummy, unsigned char *m,
    unsigned int m_len, unsigned char *sigbuf, unsigned int siglen,
    RSA *rsa);

-}

